Package org.springframework.orm.hibernate5.support

# Class OpenSessionInViewInterceptor

java.lang.Object
org.springframework.orm.hibernate5.support.OpenSessionInViewInterceptor

All Implemented Interfaces:
  `org.springframework.web.context.request.AsyncWebRequestInterceptor`, `org.springframework.web.context.request.WebRequestInterceptor`

public class OpenSessionInViewInterceptor extends Object implements org.springframework.web.context.request.AsyncWebRequestInterceptor
Spring web request interceptor that binds a Hibernate `Session` to the thread for the entire processing of the request.

This class is a concrete expression of the "Open Session in View" pattern, which is a pattern that allows for the lazy loading of associations in web views despite the original transactions already being completed.

This interceptor makes Hibernate Sessions available via the current thread, which will be autodetected by transaction managers. It is suitable for service layer transactions via `HibernateTransactionManager` as well as for non-transactional execution (if configured appropriately).

In contrast to `OpenSessionInViewFilter`, this interceptor is configured in a Spring application context and can thus take advantage of bean wiring.

WARNING: Applying this interceptor to existing logic can cause issues that have not appeared before, through the use of a single Hibernate `Session` for the processing of an entire request. In particular, the reassociation of persistent objects with a Hibernate `Session` has to occur at the very beginning of request processing, to avoid clashes with already loaded instances of the same objects.

Since:
  4.2
Author:
  Juergen Hoeller
See Also:
  - `OpenSessionInViewFilter`
  - `OpenSessionInterceptor`
  - `HibernateTransactionManager`
  - `TransactionSynchronizationManager`
  - `SessionFactory.getCurrentSession()`

## Field Summary

Fields
Modifier and Type
Field
Description
`protected final org.apache.commons.logging.Log`
`logger`
`static final String`
`PARTICIPATE_SUFFIX`
Suffix that gets appended to the `SessionFactory` `toString()` representation for the "participate in existing session handling" request attribute.

## Constructor Summary

Constructors
Constructor
Description
`OpenSessionInViewInterceptor()`

## Method Summary

Modifier and Type
Method
Description
`void`
`afterCompletion(org.springframework.web.context.request.WebRequest request, Exception ex)`
Unbind the Hibernate `Session` from the thread and close it.
`void`
`afterConcurrentHandlingStarted(org.springframework.web.context.request.WebRequest request)`
`protected String`
`getParticipateAttributeName()`
Return the name of the request attribute that identifies that a request is already intercepted.
`SessionFactory`
`getSessionFactory()`
Return the Hibernate SessionFactory that should be used to create Hibernate Sessions.
`protected Session`
`openSession()`
Open a Session for the SessionFactory that this interceptor uses.
`void`
`postHandle(org.springframework.web.context.request.WebRequest request, org.springframework.ui.ModelMap model)`
`void`
`preHandle(org.springframework.web.context.request.WebRequest request)`
Open a new Hibernate `Session` according and bind it to the thread via the `TransactionSynchronizationManager`.
`void`
`setSessionFactory(SessionFactory sessionFactory)`
Set the Hibernate SessionFactory that should be used to create Hibernate Sessions.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### PARTICIPATE_SUFFIX

public static final String PARTICIPATE_SUFFIX
Suffix that gets appended to the `SessionFactory` `toString()` representation for the "participate in existing session handling" request attribute.

See Also:
  - `getParticipateAttributeName()`
  - Constant Field Values

### logger

protected final org.apache.commons.logging.Log logger

## Constructor Details

### OpenSessionInViewInterceptor

public OpenSessionInViewInterceptor()

## Method Details

### setSessionFactory

public void setSessionFactory(@Nullable SessionFactory sessionFactory)
Set the Hibernate SessionFactory that should be used to create Hibernate Sessions.

### getSessionFactory

@Nullable public SessionFactory getSessionFactory()
Return the Hibernate SessionFactory that should be used to create Hibernate Sessions.

### preHandle

public void preHandle(org.springframework.web.context.request.WebRequest request) throws org.springframework.dao.DataAccessException
Open a new Hibernate `Session` according and bind it to the thread via the `TransactionSynchronizationManager`.

Specified by:
  `preHandle` in interface `org.springframework.web.context.request.WebRequestInterceptor`
Throws:
  `org.springframework.dao.DataAccessException`

### postHandle

public void postHandle(org.springframework.web.context.request.WebRequest request, @Nullable org.springframework.ui.ModelMap model)

Specified by:
  `postHandle` in interface `org.springframework.web.context.request.WebRequestInterceptor`

### afterCompletion

public void afterCompletion(org.springframework.web.context.request.WebRequest request, @Nullable Exception ex) throws org.springframework.dao.DataAccessException
Unbind the Hibernate `Session` from the thread and close it.

Specified by:
  `afterCompletion` in interface `org.springframework.web.context.request.WebRequestInterceptor`
Throws:
  `org.springframework.dao.DataAccessException`
See Also:
  - `TransactionSynchronizationManager`

### afterConcurrentHandlingStarted

public void afterConcurrentHandlingStarted(org.springframework.web.context.request.WebRequest request)

Specified by:
  `afterConcurrentHandlingStarted` in interface `org.springframework.web.context.request.AsyncWebRequestInterceptor`

### openSession

protected Session openSession() throws org.springframework.dao.DataAccessResourceFailureException
Open a Session for the SessionFactory that this interceptor uses.

The default implementation delegates to the `SessionFactory.openSession()` method and sets the `Session`'s flush mode to "MANUAL".

Returns:
  the Session to use
Throws:
  `org.springframework.dao.DataAccessResourceFailureException` - if the Session could not be created
See Also:
  - `FlushMode.MANUAL`

### getParticipateAttributeName

protected String getParticipateAttributeName()
Return the name of the request attribute that identifies that a request is already intercepted.

The default implementation takes the `toString()` representation of the `SessionFactory` instance and appends `PARTICIPATE_SUFFIX`.